<template>
  <div>
    <div class="bg-background2 pb-32">
      <sport-m-popular-match v-if="isRecommendMatchEnabled" class="px-6" />
      <div class="black-home-entry px-6 mt-6 mb-12">
        <template v-for="menu in menuTabHeaders" :key="menu.TabType">
          <nuxt-link
            v-if="shouldDisplayMenuTab(menu.TabType)"
            :to="menu.TabURL"
            class="w-full aspect-square home-game-tab-type-btn"
          >
            <img :src="getMenuTabContent(menu.TabType).ImagePath" />
          </nuxt-link>
        </template>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { PropType, defineComponent, computed, ref } from "vue";
import _ from "lodash";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";
import { useHeaderComponent } from "@/composables/useTheme";
import { TabInfo } from "@/models/IGetPlayableGamesResponse";
import { gameStore } from "~~/store/game";

export default defineComponent({
  name: "Home",
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const sportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_1"
        )
    );
    const virtualSportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_2"
        )
    );
    const casinoBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_3"
        )
    );
    const gamesBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_4"
        )
    );
    const cockFightBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_5"
        )
    );
    const promotionBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_6"
        )
    );
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );

    const games = computed(() => gameStore.state.games);
    const isSportEnabled = computed(() => {
      const isHidden = sportBanner.value.IsHidden;
      const sportCount = _.filter(
        games.value,
        (item) => item.Category === 1 && item.ForMobile === true
      ).length;
      return !isHidden && sportCount > 0;
    });
    const isVirtualSportEnabled = computed(() => {
      const isHidden = virtualSportBanner.value.IsHidden;
      const virtualSportCount = _.filter(
        games.value,
        (item) => item.Category === 4 && item.ForMobile === true
      ).length;
      return !isHidden && virtualSportCount > 0;
    });
    const isCasinoEnabled = computed(() => {
      const isHidden = casinoBanner.value.IsHidden;
      const casinoCount = _.filter(
        games.value,
        (item) => item.Category === 2 && item.ForMobile === true
      ).length;
      return !isHidden && casinoCount > 0;
    });
    const isGamesEnabled = computed(() => {
      const isHidden = gamesBanner.value.IsHidden;
      return !isHidden;
    });
    const isCockfightEnabled = computed(() => {
      const isHidden = cockFightBanner.value.IsHidden;
      const cockFightCount = _.filter(
        games.value,
        (item) => item.GameProviderId === 46
      ).length;
      return !isHidden && cockFightCount > 0;
    });
    const isPromotionEnabled = computed(() => {
      const isHidden = promotionBanner.value.IsHidden;
      return !isHidden;
    });

    const hasPoker = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Poker") >= 0
    );
    const hasLottery = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Lottery") >=
        0
    );
    const checkImg = (menu: TabInfo) => {
      if (menu.TabType.toLowerCase().includes("sports")) {
        return "sports";
      }
      if (menu.TabType.toLowerCase().includes("casino")) {
        return "casino";
      }
      if (menu.TabType.toLowerCase().includes("cock")) {
        return "cock";
      }
      return menu.TabType.toLowerCase();
    };
    const { menuTabHeaders } = useHeaderComponent();

    const hasBanner = ref(false);
    const getSingleThemeProperty = (key: string) =>
      themePropertyHelper.getSingleThemeProperty(themeProperties.value, key);
    const isPropertyExists = (property: IThemePropertiesFromApi) =>
      Object.keys(property).length > 0;
    const shouldDisplayMenuTab = (TabType: string) => {
      const tabType = TabType.toLowerCase();
      if (
        tabType === "sports" &&
        isPropertyExists(getSingleThemeProperty("index_blog_1")) &&
        !getSingleThemeProperty("index_blog_1").IsHidden
      )
        return true;
      if (
        tabType === "virtual sports" &&
        isPropertyExists(getSingleThemeProperty("index_blog_2")) &&
        !getSingleThemeProperty("index_blog_2").IsHidden
      )
        return true;
      if (
        tabType === "live casino" &&
        isPropertyExists(getSingleThemeProperty("index_blog_3")) &&
        !getSingleThemeProperty("index_blog_3").IsHidden
      )
        return true;
      if (
        tabType === "games" &&
        isPropertyExists(getSingleThemeProperty("index_blog_4")) &&
        !getSingleThemeProperty("index_blog_4").IsHidden
      )
        return true;
      if (
        tabType === "cock fight" &&
        isPropertyExists(getSingleThemeProperty("index_blog_5")) &&
        !getSingleThemeProperty("index_blog_5").IsHidden
      )
        return true;
      if (
        tabType === "poker" &&
        isPropertyExists(getSingleThemeProperty("index_blog_6")) &&
        !getSingleThemeProperty("index_blog_6").IsHidden
      )
        return true;
      if (
        tabType === "lottery" &&
        isPropertyExists(getSingleThemeProperty("index_blog_7")) &&
        !getSingleThemeProperty("index_blog_7").IsHidden
      )
        return true;
      if (
        tabType === "keno" &&
        isPropertyExists(getSingleThemeProperty("index_blog_8")) &&
        !getSingleThemeProperty("index_blog_8").IsHidden
      )
        return true;
      if (
        tabType === "promotion" &&
        isPropertyExists(getSingleThemeProperty("index_blog_9")) &&
        !getSingleThemeProperty("index_blog_9").IsHidden
      )
        return true;

      return false;
    };
    const getMenuTabContent = (TabType: string): IThemePropertiesFromApi => {
      const tabType = TabType.toLowerCase();
      if (tabType === "sports") return getSingleThemeProperty("index_blog_1");
      if (tabType === "virtual sports")
        return getSingleThemeProperty("index_blog_2");
      if (tabType === "live casino")
        return getSingleThemeProperty("index_blog_3");
      if (tabType === "games") return getSingleThemeProperty("index_blog_4");
      if (tabType === "cock fight")
        return getSingleThemeProperty("index_blog_5");
      if (tabType === "poker") return getSingleThemeProperty("index_blog_6");
      if (tabType === "lottery") return getSingleThemeProperty("index_blog_7");
      if (tabType === "keno") return getSingleThemeProperty("index_blog_8");
      if (tabType === "promotion")
        return getSingleThemeProperty("index_blog_9");

      return {
        HtmlId: "",
        ThemeId: 0,
        ThemeName: "",
        Type: 0,
        Path: "",
        Height: "",
        Width: "",
        HyperLink: "",
        Text: "",
        ResourceKey: "",
        IsHidden: true,
        IsDefault: false,
        Language: "",
        ImagePath: "",
      };
    };
    return {
      isSportEnabled,
      isVirtualSportEnabled,
      isCasinoEnabled,
      isGamesEnabled,
      isCockfightEnabled,
      isPromotionEnabled,
      sportBanner,
      virtualSportBanner,
      casinoBanner,
      gamesBanner,
      cockFightBanner,
      promotionBanner,
      isRecommendMatchEnabled,
      hasPoker,
      hasLottery,
      menuTabHeaders,
      checkImg,
      hasBanner,
      shouldDisplayMenuTab,
      getMenuTabContent,
    };
  },
});
</script>
<style scoped>
.black-home-entry {
  /* grid grid-cols-2 gap-4  */
  display: flex;
  flex-wrap: wrap;
  gap: 0.5rem 0.5rem;
}
.black-home-entry > .home-game-tab-type-btn {
  width: calc(50% - 0.3rem);
}
.home-game-tab-type-btn {
  position: relative;
  overflow: hidden;
  display: flex;
  border-width: 0.0625rem;
  border-style: solid;
  border-radius: 0.5rem;
  --border-opacity: 1;
  border-color: rgba(57, 60, 104, var(--border-opacity));
  --bg-opacity: 1;
  background: #252525;
  justify-content: center;
  align-items: center;
}
</style>

<style scoped>
.el-carousel__container {
  height: 125px;
}
</style>
<style lang="scss">
.mobileBannerCarouselBfm1 {
  .el-carousel__indicators {
    .el-carousel__indicator {
      &.is-active .el-carousel__button {
        background: var(--primary);
      }
      .el-carousel__button {
        width: 5px;
        height: 5px;
        border-radius: 2px;
        background: rgba(255, 255, 255, 0.5);
      }
    }
  }
  .el-carousel__container {
    .el-carousel__arrow {
      display: none;
    }
  }
}
</style>
